package cn.iocoder.yudao.module.bpm.service.business;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.bpm.controller.admin.business.vo.ModelConfigPageReqVO;
import cn.iocoder.yudao.module.bpm.controller.admin.business.vo.ModelConfigSaveReqVO;
import cn.iocoder.yudao.module.bpm.dal.dataobject.business.ModelConfigDO;

import javax.validation.Valid;

public interface ModelConfigService {

    /**
     * 创建流程模型配置
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createModelConfig(@Valid ModelConfigSaveReqVO createReqVO);

    /**
     * 更新流程模型配置
     *
     * @param updateReqVO 更新信息
     */
    void updateModelConfig(@Valid ModelConfigSaveReqVO updateReqVO);

    /**
     * 删除流程模型配置
     *
     * @param id 编号
     */
    void deleteModelConfig(Long id);

    /**
     * 获得流程模型配置
     *
     * @param id 编号
     * @return 流程模型配置
     */
    ModelConfigDO getModelConfig(Long id);

    /**
     * 获得流程模型配置分页
     *
     * @param pageReqVO 分页查询
     * @return 流程模型配置分页
     */
    PageResult<ModelConfigDO> getModelConfigPage(ModelConfigPageReqVO pageReqVO);

    void deleteModelConfigByModelId(String id);

    Integer getModelStatus(String modelKey);
}
